Index: arch/arm/kernel/fiq.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/arm/kernel/fiq.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/arm/kernel/fiq.c	22 Jul 2004 19:48:58 -0000	1.1
+++ arch/arm/kernel/fiq.c	4 Aug 2004 01:25:38 -0000	1.2
@@ -122,23 +122,23 @@
 	register unsigned long tmp, tmp2;
 	__asm__ volatile (
 #ifdef CONFIG_CPU_26
-	"mov	%0, pc
-	bic	%1, %0, #0x3
-	orr	%1, %1, %3
-	teqp	%1, #0		@ select FIQ mode
-	mov	r0, r0
-	ldmia	%2, {r8 - r14}
-	teqp	%0, #0		@ return to SVC mode
-	mov	r0, r0"
+	"mov	%0, pc                                  \n"
+	"bic	%1, %0, #0x3                            \n"
+	"orr	%1, %1, %3                              \n"
+	"teqp	%1, #0		@ select FIQ mode       \n"
+	"mov	r0, r0                                  \n"
+	"ldmia	%2, {r8 - r14}                          \n"
+	"teqp	%0, #0		@ return to SVC mode    \n"
+	"mov	r0, r0                                  \n"
 #endif
 #ifdef CONFIG_CPU_32
-	"mrs	%0, cpsr
-	mov	%1, %3
-	msr	cpsr_c, %1	@ select FIQ mode
-	mov	r0, r0
-	ldmia	%2, {r8 - r14}
-	msr	cpsr_c, %0	@ return to SVC mode
-	mov	r0, r0"
+	"mrs	%0, cpsr                                \n"
+	"mov	%1, %3                                  \n"
+	"msr	cpsr_c, %1	@ select FIQ mode       \n"
+	"mov	r0, r0                                  \n"
+	"ldmia	%2, {r8 - r14}                          \n"
+	"msr	cpsr_c, %0	@ return to SVC mode    \n"
+	"mov	r0, r0                                  \n"
 #endif
 	: "=&r" (tmp), "=&r" (tmp2)
 	: "r" (&regs->ARM_r8), "I" (I_BIT | F_BIT | FIQ_MODE)
@@ -154,23 +154,23 @@
 	register unsigned long tmp, tmp2;
 	__asm__ volatile (
 #ifdef CONFIG_CPU_26
-	"mov	%0, pc
-	bic	%1, %0, #0x3
-	orr	%1, %1, %3
-	teqp	%1, #0		@ select FIQ mode
-	mov	r0, r0
-	stmia	%2, {r8 - r14}
-	teqp	%0, #0		@ return to SVC mode
-	mov	r0, r0"
+	"mov	%0, pc                               \n"
+	"bic	%1, %0, #0x3                         \n"
+	"orr	%1, %1, %3                           \n"
+	"teqp	%1, #0		@ select FIQ mode    \n"
+	"mov	r0, r0                               \n"
+	"stmia	%2, {r8 - r14}                       \n"
+	"teqp	%0, #0		@ return to SVC mode \n"
+	"mov	r0, r0                               \n"
 #endif
 #ifdef CONFIG_CPU_32
-	"mrs	%0, cpsr
-	mov	%1, %3
-	msr	cpsr_c, %1	@ select FIQ mode
-	mov	r0, r0
-	stmia	%2, {r8 - r14}
-	msr	cpsr_c, %0	@ return to SVC mode
-	mov	r0, r0"
+	"mrs	%0, cpsr                             \n"
+	"mov	%1, %3                               \n"
+	"msr	cpsr_c, %1	@ select FIQ mode    \n"
+	"mov	r0, r0                               \n"
+	"stmia	%2, {r8 - r14}                       \n"
+	"msr	cpsr_c, %0	@ return to SVC mode \n"
+	"mov	r0, r0                               \n"
 #endif
 	: "=&r" (tmp), "=&r" (tmp2)
 	: "r" (&regs->ARM_r8), "I" (I_BIT | F_BIT | FIQ_MODE)
Index: arch/arm/kernel/head-armv.S
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/arm/kernel/head-armv.S,v
retrieving revision 1.1
retrieving revision 1.4
diff -u -r1.1 -r1.4
--- arch/arm/kernel/head-armv.S	22 Jul 2004 19:48:58 -0000	1.1
+++ arch/arm/kernel/head-armv.S	7 Jul 2006 18:10:43 -0000	1.4
@@ -1,7 +1,7 @@
 /*
  *  linux/arch/arm/kernel/head-armv.S
  *
- *  Copyright (C) 1994-1999 Russell King
+ *  Copyright (C) 1994-2003 Russell King
  *
  * This program is free software; you can redistribute it and/or modify
  * it under the terms of the GNU General Public License version 2 as
@@ -184,63 +184,6 @@
 		mov32	r13, 0x10000
 		/* End of code for bootloader */
 
-
-		/*
-		 * do a write to CLKSET1 to set up the clocks.
-		 * Then do 5 nops to flush the pipe because we're supposed to.
-		 */
-		mov32	r0, SYSCON_BASE
-		mov32	r1, CLKSET1_VALUE  
-		str	r1, [r0, #0x20]
-		nop
-		nop
-		nop
-		nop
-		nop
-
-		/*
-		 * Program up PLL2
-		 */
-		mov32	r0, SYSCON_BASE
-		mov32	r1, CLKSET2_VALUE
-		str		r1, [r0, #0x24]
-
-		/*
-		 * Do a 1 mSec delay for PLL2 to stabilize using TC4.
-		 * Enable the TC4
-		 */
-		mov32	r0, TIMERS_BASE
-		mov32	r1, 0x00000100
-		str		r1, [r0, #0x64]
-
-		/*
-		 * Get current timer value, add 1000 (uSec) to it.
-		 */
-		mov32	r0, TIMER4VALUELOW
-		ldr		r1, [r0]
-		mov32	r2, 1000
-		add		r1, r1, r2
-
-		/*
-		 * Get current timer value, loop until greater than r1
-		 */
-1:		ldr		r2, [r0]
-		cmp		r2, r1
-		blt		1b
-
-		/*
-		 * Pointer to the Syscon base
-		 */
-		mov32	r0, SYSCON_BASE
-
-		/*
-		 * Setup the UARTBAUD bit in the PWRCNT register. This
-		 * enables the 14.7456MHz clock to the UARTs.  Everything
-		 * else in this register (DMA, USB, IRDA) is zeroed.
-		 */
-		mov32 	r1, 0x20000000
-		str	r1, [r0, #0x04]
- 
 #endif	
 		/* 
 		 * TODO - RedBoot does not set 'r1' with our architecture
@@ -290,18 +233,16 @@
  */
 		.type	__ret, %function
 __ret:		ldr	lr, __switch_data
-
 #if defined(CONFIG_ARCH_EP9301) || defined(CONFIG_ARCH_EP9312) || defined(CONFIG_ARCH_EP9315)
-		/*
-		 * Put us in Async mode
-		 */
-		orr	r0, r0, #0xC0000000
-#endif
-
-		mcr	p15, 0, r0, c1, c0
-		mrc	p15, 0, r0, c1, c0, 0		@ read it back.
-		mov	r0, r0
-		mov	r0, r0
+ 		/*
+ 		 * Put us in Async mode
+ 		 */
+ 		orr	r0, r0, #0xC0000000
+ #endif
+		mcr	p15, 0, r0, c1, c0, 0
+		mrc	p15, 0, r3, c0, c0, 0
+		mov	r3, r3
+		mov	r3, r3
 		mov	pc, lr
 
 /*
@@ -349,6 +290,11 @@
  */
 __create_page_tables:
 		pgtbl	r4, r5				@ page table address
+#if defined(CONFIG_CPU_DCACHE_DISABLE)
+		bic	r8, r8, #0x00c			@ clear B, C
+#elif defined(CONFIG_CPU_DCACHE_WRITETHROUGH)
+		bic	r8, r8, #0x004			@ clear B
+#endif
 
 		/*
 		 * Clear the 16K level 1 swapper page table
Index: arch/arm/kernel/irq.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/arm/kernel/irq.c,v
retrieving revision 1.1
retrieving revision 1.4
diff -u -r1.1 -r1.4
--- arch/arm/kernel/irq.c	22 Jul 2004 19:48:58 -0000	1.1
+++ arch/arm/kernel/irq.c	13 Jan 2009 19:28:09 -0000	1.4
@@ -30,13 +30,34 @@
 #include <linux/list.h>
 #include <linux/timer.h>
 #include <linux/init.h>
+#include <linux/proc_fs.h>
+#include <linux/irq.h>
+#include <linux/poll.h>
 
 #include <asm/irq.h>
+#include <asm/poll.h>
 #include <asm/system.h>
 #include <asm/mach/irq.h>
+#include <asm/io.h>
+#include <asm/arch/hardware.h>
+
 
 #include <asm/arch/irq.h>	/* pick up fixup_irq definition */
 
+static struct proc_dir_entry *root_irq_dir;
+
+#undef MAX_NAMELEN
+ 
+#define MAX_NAMELEN 10
+ 
+struct irq_proc {
+	unsigned long irq;
+	wait_queue_head_t q;
+	atomic_t count;
+	char devname[TASK_COMM_LEN];
+};
+
+
 /*
  * Maximum IRQ count.  Currently, this is arbitary.  However, it should
  * not be set too low to prevent false triggering.  Conversely, if it
@@ -104,12 +125,10 @@
 	struct irqdesc *desc = irq_desc + irq;
 	unsigned long flags;
 
-       spin_lock_irqsave(&irq_controller_lock, flags);
-
+	spin_lock_irqsave(&irq_controller_lock, flags);
 	if (!desc->disable_depth) {
-	//	printk("enable_irq(%u) unbalanced from %p\n", irq,
-       //       	__builtin_return_address(0));
-         //The IRQ has been enabled. just do nothing.
+		printk("enable_irq(%u) unbalanced from %p\n", irq,
+			__builtin_return_address(0));
 	} else if (!--desc->disable_depth) {
 		desc->probing = 0;
 		desc->unmask(irq);
@@ -314,6 +333,8 @@
 {
 	irq = fixup_irq(irq);
 
+	if (irq == 22) 
+		outl((1<<3), GPIO_FEOI);
 	/*
 	 * Some hardware gives randomly wrong interrupts.  Rather
 	 * than crashing, do something sensible.
@@ -662,8 +683,180 @@
 	return irq_found;
 }
 
+static void irq_proc_irq_handler(int irq, void *vidp, struct pt_regs *regs)
+{
+	struct irq_proc *idp = (struct irq_proc *)vidp;
+
+	BUG_ON(idp->irq != irq);
+	disable_irq_nosync(irq);
+	atomic_inc(&idp->count);
+	wake_up(&idp->q);
+	return ;
+}
+
+
+static int irq_proc_open(struct inode *inop, struct file *filp)
+{
+	struct irq_proc *ip;
+	struct proc_dir_entry *ent = PDE(inop);
+	int error;
+
+	ip = kmalloc(sizeof *ip, GFP_KERNEL);
+	if (ip == NULL)
+		return -ENOMEM;
+
+	memset(ip, 0, sizeof(*ip));
+	strcpy(ip->devname, current->comm);
+	init_waitqueue_head(&ip->q);
+	atomic_set(&ip->count, 0);
+	ip->irq = (unsigned long)ent->data;
+
+	error = request_irq(ip->irq,
+		irq_proc_irq_handler,
+		SA_INTERRUPT,
+		ip->devname,
+		ip);
+	if (error < 0) {
+		kfree(ip);
+		return error;
+	}
+	filp->private_data = (void *)ip;
+
+	return 0;
+}
+
+static int irq_proc_release(struct inode *inop, struct file *filp)
+{
+	struct irq_proc *ip = (struct irq_proc *)filp->private_data;
+
+	free_irq(ip->irq, ip);
+	filp->private_data = NULL;
+	kfree(ip);
+	return 0;
+}
+
+static unsigned int irq_proc_poll(struct file *filp, struct poll_table_struct *wait)
+{
+	struct irq_proc *ip = (struct irq_proc *)filp->private_data;
+
+//EWD: we get a warning for the following line(irq_desc_t vs irq_desc)
+	irq_desc_t *idp = irq_desc + ip->irq;
+
+	if (atomic_read(&ip->count) > 0)
+		return POLLIN | POLLRDNORM; /* readable */
+
+	/* if interrupts disabled and we don't have one to process... */
+	if (idp->status & IRQ_DISABLED)
+		enable_irq(ip->irq);
+
+	poll_wait(filp, &ip->q, wait);
+
+	if (atomic_read(&ip->count) > 0)
+		return POLLIN | POLLRDNORM; /* readable */
+
+	return 0;
+}
+
+
+/*
+ * Signal to userspace an interrupt has occured.
+ */
+static ssize_t irq_proc_read(struct file *filp, char  /*__user*/ *bufp, size_t len, loff_t *ppos)
+{
+	struct irq_proc *ip = (struct irq_proc *)filp->private_data;
+//EWD: we get a warning for the following line(irq_desc_t vs irq_desc)
+	irq_desc_t *idp = irq_desc + ip->irq;
+	int pending;
+
+	DECLARE_WAIT_QUEUE_HEAD(queue);
+	DECLARE_WAITQUEUE(wait, current);
+
+	if (len < sizeof(int))
+		return -EINVAL;
+
+	pending = atomic_read(&ip->count);
+	if (pending == 0) {
+		if (idp->status & IRQ_DISABLED)
+			enable_irq(ip->irq);
+			if (filp->f_flags & O_NONBLOCK)
+				return -EWOULDBLOCK;
+	}	
+
+	while (pending == 0) {
+		add_wait_queue(&queue, &wait);
+		set_current_state(TASK_INTERRUPTIBLE);
+
+		pending = atomic_read(&ip->count);
+		if (pending == 0)
+			schedule();
+		remove_wait_queue(&queue, &wait);
+		if (signal_pending(current))
+			return -ERESTARTSYS;
+		set_current_state(TASK_RUNNING);
+	}
+
+	if (copy_to_user(bufp, &pending, sizeof pending))
+		return -EFAULT;
+
+	*ppos += sizeof pending;
+
+	atomic_sub(pending, &ip->count);
+	return sizeof pending;
+}
+
+
+static struct file_operations irq_proc_file_operations = {
+	.read = irq_proc_read,
+	.open = irq_proc_open,
+	.release = irq_proc_release,
+	.poll = irq_proc_poll,
+};
+
+#define MAX_NAMELEN 10
+void register_irq_proc(unsigned int irq)
+{
+	struct proc_dir_entry *entry;
+	char name [MAX_NAMELEN];
+
+	if (!root_irq_dir)
+		return;
+
+	memset(name, 0, MAX_NAMELEN);
+	sprintf(name, "%d", irq);
+
+	if (!irq_desc[irq].dir) {
+		/* create /proc/irq/1234 */
+		irq_desc[irq].dir = proc_mkdir(name, root_irq_dir);
+
+		/*
+		* Create handles for user-mode interrupt handlers
+		* if the kernel hasn't already grabbed the IRQ
+		*/
+		entry = create_proc_entry("irq", 0600, irq_desc[irq].dir);
+		if (entry) {
+			entry->data = (void *)(unsigned long)irq;
+			entry->read_proc = NULL;
+			entry->write_proc = NULL;
+			entry->proc_fops = &irq_proc_file_operations;
+		}
+	}
+}
+
+
 void __init init_irq_proc(void)
 {
+	int i;
+
+	/* create /proc/irq */
+	root_irq_dir = proc_mkdir("irq", NULL);
+	if (!root_irq_dir)
+		return;
+
+	/*
+	* Create entries for all existing IRQs.
+	*/
+	for (i = 0; i < NR_IRQS; i++)
+		register_irq_proc(i);
 }
 
 void __init init_IRQ(void)
Index: arch/arm/kernel/isa.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/arm/kernel/isa.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/arm/kernel/isa.c	22 Jul 2004 19:48:58 -0000	1.1
+++ arch/arm/kernel/isa.c	4 Aug 2004 01:25:38 -0000	1.2
@@ -38,7 +38,7 @@
 
 static struct ctl_table_header *isa_sysctl_header;
 
-static ctl_table ctl_isa[2] = {{BUS_ISA, "isa", NULL, 0, 0555, ctl_isa_vars},
+static ctl_table ctl_isa[2] = {{CTL_BUS_ISA, "isa", NULL, 0, 0555, ctl_isa_vars},
 			       {0}};
 static ctl_table ctl_bus[2] = {{CTL_BUS, "bus", NULL, 0, 0555, ctl_isa},
 			       {0}};
Index: arch/arm/kernel/ptrace.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/arm/kernel/ptrace.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/arm/kernel/ptrace.c	22 Jul 2004 19:48:58 -0000	1.1
+++ arch/arm/kernel/ptrace.c	4 Aug 2004 01:25:38 -0000	1.2
@@ -725,11 +725,8 @@
 		goto out_tsk;
 	}
 	ret = -ESRCH;
-	if (!(child->ptrace & PT_PTRACED))
-		goto out_tsk;
-	if (child->state != TASK_STOPPED && request != PTRACE_KILL)
-		goto out_tsk;
-	if (child->p_pptr != current)
+	ret = ptrace_check_attach(child, request == PTRACE_KILL);
+	if (ret)
 		goto out_tsk;
 
 	ret = do_ptrace(request, child, addr, data);
Index: arch/arm/lib/Makefile
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/arm/lib/Makefile,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/arm/lib/Makefile	22 Jul 2004 19:48:57 -0000	1.1
+++ arch/arm/lib/Makefile	4 Aug 2004 01:25:39 -0000	1.2
@@ -15,7 +15,7 @@
 		   strnlen_user.o strchr.o strrchr.o testchangebit.o  \
 		   testclearbit.o testsetbit.o uaccess.o getuser.o    \
 		   putuser.o ashldi3.o ashrdi3.o lshrdi3.o muldi3.o   \
-		   ucmpdi2.o udivdi3.o lib1funcs.o
+		   ucmpdi2.o udivdi3.o lib1funcs.o div64.o
 obj-m		:=
 obj-n		:=
 
Index: arch/arm/lib/putuser.S
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/arm/lib/putuser.S,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/arm/lib/putuser.S	22 Jul 2004 19:48:57 -0000	1.1
+++ arch/arm/lib/putuser.S	4 Aug 2004 01:25:39 -0000	1.2
@@ -30,11 +30,11 @@
 
 	.global	__put_user_1
 __put_user_1:
-	bic	r2, sp, #0x1f00
-	bic	r2, r2, #0x00ff
-	ldr	r2, [r2, #TSK_ADDR_LIMIT]
-	sub	r2, r2, #1
-	cmp	r0, r2
+	bic	ip, sp, #0x1f00
+	bic	ip, ip, #0x00ff
+	ldr	ip, [ip, #TSK_ADDR_LIMIT]
+	sub	ip, ip, #1
+	cmp	r0, ip
 1:	strlsbt	r1, [r0]
 	movls	r0, #0
 	movls	pc, lr
@@ -42,11 +42,11 @@
 
 	.global	__put_user_2
 __put_user_2:
-	bic	r2, sp, #0x1f00
-	bic	r2, r2, #0x00ff
-	ldr	r2, [r2, #TSK_ADDR_LIMIT]
-	sub	r2, r2, #2
-	cmp	r0, r2
+	bic	ip, sp, #0x1f00
+	bic	ip, ip, #0x00ff
+	ldr	ip, [ip, #TSK_ADDR_LIMIT]
+	sub	ip, ip, #2
+	cmp	r0, ip
 2:	strlsbt	r1, [r0], #1
 	movls	r1, r1, lsr #8
 3:	strlsbt	r1, [r0]
@@ -56,11 +56,11 @@
 
 	.global	__put_user_4
 __put_user_4:
-	bic	r2, sp, #0x1f00
-	bic	r2, r2, #0x00ff
-	ldr	r2, [r2, #TSK_ADDR_LIMIT]
-	sub	r2, r2, #4
-	cmp	r0, r2
+	bic	ip, sp, #0x1f00
+	bic	ip, ip, #0x00ff
+	ldr	ip, [ip, #TSK_ADDR_LIMIT]
+	sub	ip, ip, #4
+	cmp	r0, ip
 4:	strlst	r1, [r0]
 	movls	r0, #0
 	movls	pc, lr
Index: arch/arm/mach-at91rm9200/Makefile
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/arm/mach-at91rm9200/Makefile,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/arm/mach-at91rm9200/Makefile	22 Jul 2004 19:48:58 -0000	1.1
+++ arch/arm/mach-at91rm9200/Makefile	4 Aug 2004 01:25:39 -0000	1.2
@@ -18,4 +18,8 @@
 
 export-objs		:=
 
+# LEDs support
+leds-$(CONFIG_ARCH_AT91RM9200DK) += dk-leds.o
+obj-$(CONFIG_LEDS) += $(leds-y)
+
 include $(TOPDIR)/Rules.make
Index: arch/arm/mach-ep93xx/arch.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/arm/mach-ep93xx/arch.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/arm/mach-ep93xx/arch.c	22 Jul 2004 19:48:59 -0000	1.1
+++ arch/arm/mach-ep93xx/arch.c	4 Aug 2004 01:25:39 -0000	1.2
@@ -44,7 +44,7 @@
 
 #ifdef CONFIG_ARCH_EP9301
 MACHINE_START(EP9301, "ep9301")
-    MAINTAINER("Cirrus Logic")
+    MAINTAINER("Cirrus Logic; Technologic Systems")
     BOOT_MEM( SDRAM_START, 0x80000000, 0x80000000 )
     BOOT_PARAMS( SDRAM_START + 0x00000100 )
     MAPIO(ep93xx_map_io)
Index: arch/arm/mach-ep93xx/dma_ep93xx.h
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/arm/mach-ep93xx/dma_ep93xx.h,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/arm/mach-ep93xx/dma_ep93xx.h	22 Jul 2004 19:48:59 -0000	1.1
+++ arch/arm/mach-ep93xx/dma_ep93xx.h	29 Sep 2006 22:25:11 -0000	1.2
@@ -1,195 +1,195 @@
-/*****************************************************************************
- *
- * arch/arm/mach-ep93xx/dma_ep93xx.h
- *
- * DESCRIPTION:    93XX DMA controller API private defintions.
- *
- * Copyright Cirrus Logic Corporation, 2003.  All rights reserved
- *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation; either version 2 of the License, or
- * (at your option) any later version.
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
- *
- ****************************************************************************/
-#ifndef _EP93XX_DMA_H_
-#define _EP93XX_DMA_H_
-
-#define MAX_EP93XX_DMA_BUFFERS      32
-
-#ifndef TRUE
-#define TRUE                        1
-#endif
-
-#ifndef FALSE
-#define FALSE                       0
-#endif
-
-#ifndef NULL
-#define NULL                        0
-#endif
-
-/*****************************************************************************
- *
- * DMA buffer structure type.
- *
- ****************************************************************************/
-typedef struct ep93xx_dma_buffer_s
-{
-    unsigned int    source;     /* buffer physical source address.          */
-    unsigned int    dest;       /* buffer physical destination address,     */
-                                /* only used with the 2 M2M channels.       */
-    unsigned int    size;       /* buffer size in bytes                     */
-    unsigned int    last;       /* 1 if this is the last buffer             */
-                                /* in this transaction.  If 1,              */
-                                /* disable the NFBint so we aren't          */
-                                /* interrupted for another buffer           */
-                                /* when we know there won't be another.     */
-    unsigned int    used;       /* This field is set to 1 by the DMA        */
-                                /* interface after the buffer is transferred*/
-    int    buf_id;              /* unique identifyer specified by the       */
-                                /* the driver which requested the dma       */
-} ep93xx_dma_buffer_t;
-
-typedef ep93xx_dma_buffer_t * ep93xx_dma_buffer_p;
-
-/*****************************************************************************
- *
- * Instance definition for the DMA interface.
- *
- ****************************************************************************/
-typedef struct ep7312_dma_s
-{
-    /*
-     *  This 1 when the instance is in use, and 0 when it's not.
-     */
-    unsigned int ref_count;
-
-    /*
-     * This is the last valid handle for this instance.  When giving out a
-     * new handle this will be incremented and given out.
-     */
-    int last_valid_handle;
-
-    /*
-     * device specifies one of the 20 DMA hardware ports this 
-     * DMA channel will service.
-     */
-    ep93xx_dma_dev_t device;
-
-    /*
-     * DMABufferQueue is the queue of buffer structure pointers which the
-     * dma channel will use to setup transfers.
-     */
-    ep93xx_dma_buffer_t buffer_queue[MAX_EP93XX_DMA_BUFFERS];
-
-    /*
-     * currnt_buffer : This is the buffer currently being transfered on 
-     *                 this channel.
-     * last_buffer : This is the last buffer for this transfer.
-     * Note: current_buffer + 1 is already programmed into the dma
-     *       channel as the next buffer to transfer. Don't write
-     *       over either entry.
-     */
-    int current_buffer;
-    int last_buffer;
-
-    /*
-     * The following 3 fields are buffer counters.
-     *
-     * iNewBuffers: Buffers in the queue which have not been transfered.
-     * iUsedBuffers: Buffers in the queue which have have been tranferred,
-     *               and are waiting to be returned.
-     * iTotalBuffers: Total number of buffers in the queue.
-     */  
-    int new_buffers;
-    int used_buffers;
-    int total_buffers;
-
-    /*
-     * uiTotalBytes has the total bytes transfered on the channel since the
-     * last flush.  This value does not include the bytes tranfered in the
-     * current buffer.  A byte count is only added after a complete buffer
-     * is tranfered. 
-     */
-    unsigned int total_bytes;
-
-    /*
-     *  Interrupt number for this channel
-     */
-    unsigned int irq;
-
-    /*
-     * Indicates whether or not the channel is currently enabled to transfer
-     * data.
-     */
-    unsigned int xfer_enable;
-    
-    /*
-     * pause indicates if the dma channel was paused by calling the pause
-     * ioctl.
-     */
-    unsigned int pause;
-    
-    /*
-     *  buffer structure used during a pause to capture the current
-     *  address and remaining bytes for the buffer actively being transferred
-     *  on the channel. This buffer will be used to reprogram the dma 
-     *  channel upon a resume.
-     */
-    ep93xx_dma_buffer_t pause_buf;
-    
-    /*
-     * DMACallback is a function pointer which the calling application can 
-     * use install a function to.  this fuction can be used to notify the 
-     * calling application of an interrupt.
-     */
-    dma_callback callback;
-
-    /*
-     * User data used as a parameter for the Callback function.  The user
-     * sets up the data and sends it with the callback function.
-     */
-    unsigned int user_data;
-    
-    /*
-     * A string representation of the device attached to the channel.
-     */
-    const char * device_id;
-    
-    /*
-     * The register base address for this dma channel.
-     */
-    unsigned int reg_base;
-    
-} ep93xx_dma_t;
-
-/*****************************************************************************
- *
- * DMA macros
- *
- ****************************************************************************/
-#define DMA_HANDLE_SPECIFIER_MASK   0xF0000000
-#define DMA_CH0_HANDLE_SPECIFIER    0x00000000
-#define DMA_CH1_HANDLE_SPECIFIER    0x10000000
-#define DMA_CH2_HANDLE_SPECIFIER    0x20000000
-#define DMA_CH3_HANDLE_SPECIFIER    0x30000000
-#define DMA_CH4_HANDLE_SPECIFIER    0x40000000
-#define DMA_CH5_HANDLE_SPECIFIER    0x50000000
-#define DMA_CH6_HANDLE_SPECIFIER    0x60000000
-#define DMA_CH7_HANDLE_SPECIFIER    0x70000000
-#define DMA_CH8_HANDLE_SPECIFIER    0x80000000
-#define DMA_CH9_HANDLE_SPECIFIER    0x90000000
-#define DMA_CH10_HANDLE_SPECIFIER   0xA0000000
-#define DMA_CH11_HANDLE_SPECIFIER   0xB0000000
-
-#endif // _DMADRV_H_
+/*****************************************************************************
+ *
+ * arch/arm/mach-ep93xx/dma_ep93xx.h
+ *
+ * DESCRIPTION:    93XX DMA controller API private defintions.
+ *
+ * Copyright Cirrus Logic Corporation, 2003.  All rights reserved
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ ****************************************************************************/
+#ifndef _EP93XX_DMA_H_
+#define _EP93XX_DMA_H_
+
+#define MAX_EP93XX_DMA_BUFFERS      32
+
+#ifndef TRUE
+#define TRUE                        1
+#endif
+
+#ifndef FALSE
+#define FALSE                       0
+#endif
+
+#ifndef NULL
+#define NULL                        0
+#endif
+
+/*****************************************************************************
+ *
+ * DMA buffer structure type.
+ *
+ ****************************************************************************/
+typedef struct ep93xx_dma_buffer_s
+{
+    unsigned int    source;     /* buffer physical source address.          */
+    unsigned int    dest;       /* buffer physical destination address,     */
+                                /* only used with the 2 M2M channels.       */
+    unsigned int    size;       /* buffer size in bytes                     */
+    unsigned int    last;       /* 1 if this is the last buffer             */
+                                /* in this transaction.  If 1,              */
+                                /* disable the NFBint so we aren't          */
+                                /* interrupted for another buffer           */
+                                /* when we know there won't be another.     */
+    unsigned int    used;       /* This field is set to 1 by the DMA        */
+                                /* interface after the buffer is transferred*/
+    int    buf_id;              /* unique identifyer specified by the       */
+                                /* the driver which requested the dma       */
+} ep93xx_dma_buffer_t;
+
+typedef ep93xx_dma_buffer_t * ep93xx_dma_buffer_p;
+
+/*****************************************************************************
+ *
+ * Instance definition for the DMA interface.
+ *
+ ****************************************************************************/
+typedef struct ep9312_dma_s
+{
+    /*
+     *  This 1 when the instance is in use, and 0 when it's not.
+     */
+    unsigned int ref_count;
+
+    /*
+     * This is the last valid handle for this instance.  When giving out a
+     * new handle this will be incremented and given out.
+     */
+    int last_valid_handle;
+
+    /*
+     * device specifies one of the 20 DMA hardware ports this 
+     * DMA channel will service.
+     */
+    ep93xx_dma_dev_t device;
+
+    /*
+     * DMABufferQueue is the queue of buffer structure pointers which the
+     * dma channel will use to setup transfers.
+     */
+    ep93xx_dma_buffer_t buffer_queue[MAX_EP93XX_DMA_BUFFERS];
+
+    /*
+     * currnt_buffer : This is the buffer currently being transfered on 
+     *                 this channel.
+     * last_buffer : This is the last buffer for this transfer.
+     * Note: current_buffer + 1 is already programmed into the dma
+     *       channel as the next buffer to transfer. Don't write
+     *       over either entry.
+     */
+    int current_buffer;
+    int last_buffer;
+
+    /*
+     * The following 3 fields are buffer counters.
+     *
+     * iNewBuffers: Buffers in the queue which have not been transfered.
+     * iUsedBuffers: Buffers in the queue which have have been tranferred,
+     *               and are waiting to be returned.
+     * iTotalBuffers: Total number of buffers in the queue.
+     */  
+    int new_buffers;
+    int used_buffers;
+    int total_buffers;
+
+    /*
+     * uiTotalBytes has the total bytes transfered on the channel since the
+     * last flush.  This value does not include the bytes tranfered in the
+     * current buffer.  A byte count is only added after a complete buffer
+     * is tranfered. 
+     */
+    unsigned int total_bytes;
+
+    /*
+     *  Interrupt number for this channel
+     */
+    unsigned int irq;
+
+    /*
+     * Indicates whether or not the channel is currently enabled to transfer
+     * data.
+     */
+    unsigned int xfer_enable;
+    
+    /*
+     * pause indicates if the dma channel was paused by calling the pause
+     * ioctl.
+     */
+    unsigned int pause;
+    
+    /*
+     *  buffer structure used during a pause to capture the current
+     *  address and remaining bytes for the buffer actively being transferred
+     *  on the channel. This buffer will be used to reprogram the dma 
+     *  channel upon a resume.
+     */
+    ep93xx_dma_buffer_t pause_buf;
+    
+    /*
+     * DMACallback is a function pointer which the calling application can 
+     * use install a function to.  this fuction can be used to notify the 
+     * calling application of an interrupt.
+     */
+    dma_callback callback;
+
+    /*
+     * User data used as a parameter for the Callback function.  The user
+     * sets up the data and sends it with the callback function.
+     */
+    unsigned int user_data;
+    
+    /*
+     * A string representation of the device attached to the channel.
+     */
+    const char * device_id;
+    
+    /*
+     * The register base address for this dma channel.
+     */
+    unsigned int reg_base;
+    
+} ep93xx_dma_t;
+
+/*****************************************************************************
+ *
+ * DMA macros
+ *
+ ****************************************************************************/
+#define DMA_HANDLE_SPECIFIER_MASK   0xF0000000
+#define DMA_CH0_HANDLE_SPECIFIER    0x00000000
+#define DMA_CH1_HANDLE_SPECIFIER    0x10000000
+#define DMA_CH2_HANDLE_SPECIFIER    0x20000000
+#define DMA_CH3_HANDLE_SPECIFIER    0x30000000
+#define DMA_CH4_HANDLE_SPECIFIER    0x40000000
+#define DMA_CH5_HANDLE_SPECIFIER    0x50000000
+#define DMA_CH6_HANDLE_SPECIFIER    0x60000000
+#define DMA_CH7_HANDLE_SPECIFIER    0x70000000
+#define DMA_CH8_HANDLE_SPECIFIER    0x80000000
+#define DMA_CH9_HANDLE_SPECIFIER    0x90000000
+#define DMA_CH10_HANDLE_SPECIFIER   0xA0000000
+#define DMA_CH11_HANDLE_SPECIFIER   0xB0000000
+
+#endif // _DMADRV_H_
Index: arch/arm/mach-ep93xx/irq.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/arm/mach-ep93xx/irq.c,v
retrieving revision 1.1
retrieving revision 1.3
diff -u -r1.1 -r1.3
--- arch/arm/mach-ep93xx/irq.c	22 Jul 2004 19:48:59 -0000	1.1
+++ arch/arm/mach-ep93xx/irq.c	30 Jun 2005 22:11:52 -0000	1.3
@@ -78,6 +78,14 @@
 {
 	unsigned int i;
 
+	/* High level sensitive GPIO interrupt on Port F bit 2 */
+    	outl(inl(GPIO_PFDDR) & ~(1<<3), GPIO_PFDDR); /* high-Z intr pin */
+    	outl(inl(GPIO_FDB) & ~(1<<3), GPIO_FDB); /* no debounce */
+    	outl(inl(GPIO_INTTYPE1) | (1<<3), GPIO_INTTYPE1); /* edge sensitive */
+    	outl(inl(GPIO_INTTYPE2) | (1<<3), GPIO_INTTYPE2); /* high sensitive */
+    	outl(1<<3, GPIO_FEOI); /* clear edge */
+    	outl(inl(GPIO_INTEN) | (1<<3), GPIO_INTEN); /* enable */
+
     /*
      * Interrupt bits 0 and 1 are unused 
      */ 
